/*	Copyright (c) 1990, 1991, 1992, 1993, 1994 Novell, Inc. All Rights Reserved.	*/
/*	Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 Novell, Inc. All Rights Reserved.	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF Novell Inc.	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ident	"@(#)libnsl:common/lib/libnsl/rpc/key_prot.c	1.1.10.1"
#ident	"$Header: $"

/*
 * Sun RPC is a product of Sun Microsystems, Inc. and is provided for
 * unrestricted use provided that this legend is included on all tape
 * media and as a part of the software program in whole or part.  Users
 * may copy or modify Sun RPC without charge, but are not authorized
 * to license or distribute it to anyone else except as part of a product or
 * program developed by the user.
 *
 * SUN RPC IS PROVIDED AS IS WITH NO WARRANTIES OF ANY KIND INCLUDING THE
 * WARRANTIES OF DESIGN, MERCHANTIBILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE, OR ARISING FROM A COURSE OF DEALING, USAGE OR TRADE PRACTICE.
 *
 * Sun RPC is provided with no support and without any obligation on the
 * part of Sun Microsystems, Inc. to assist in its use, correction,
 * modification or enhancement.
 *
 * SUN MICROSYSTEMS, INC. SHALL HAVE NO LIABILITY WITH RESPECT TO THE
 * INFRINGEMENT OF COPYRIGHTS, TRADE SECRETS OR ANY PATENTS BY SUN RPC
 * OR ANY PART THEREOF.
 *
 * In no event will Sun Microsystems, Inc. be liable for any lost revenue
 * or profits or other special, indirect and consequential damages, even if
 * Sun has been advised of the possibility of such damages.
 *
 * Sun Microsystems, Inc.
 * 2550 Garcia Avenue
 * Mountain View, California  94043
 *
 * Copyright (c) 1986-1991 by Sun Microsystems Inc.
 */

/*
 * key_prot.c
 * 
 * Compiled from key_prot.x using rpcgen.
 * DO NOT EDIT THIS FILE!
 * This is NOT source code!
 */

#include <rpc/rpc.h>
#include <rpc/key_prot.h>
#include "trace.h"

bool_t
xdr_keystatus(xdrs, objp)
	XDR *xdrs;
	keystatus *objp;
{
	trace1(TR_xdr_keystatus, 0);
	if (!xdr_enum(xdrs, (enum_t *)objp)) {
		trace1(TR_xdr_keystatus, 1);
		return (FALSE);
	}
	trace1(TR_xdr_keystatus, 1);
	return (TRUE);
}

bool_t
xdr_keybuf(xdrs, objp)
	XDR *xdrs;
	keybuf objp;
{
	trace1(TR_xdr_keybuf, 0);
	if (!xdr_opaque(xdrs, objp, HEXKEYBYTES)) {
		trace1(TR_xdr_keybuf, 1);
		return (FALSE);
	}
	trace1(TR_xdr_keybuf, 1);
	return (TRUE);
}

bool_t
xdr_netnamestr(xdrs, objp)
	XDR *xdrs;
	netnamestr *objp;
{
	trace1(TR_xdr_netnamestr, 0);
	if (!xdr_string(xdrs, objp, MAXNETNAMELEN)) {
		trace1(TR_xdr_netnamestr, 1);
		return (FALSE);
	}
	trace1(TR_xdr_netnamestr, 1);
	return (TRUE);
}

bool_t
xdr_cryptkeyarg(xdrs, objp)
	XDR *xdrs;
	cryptkeyarg *objp;
{
	trace1(TR_xdr_cryptkeyarg, 0);
	if (!xdr_netnamestr(xdrs, &objp->remotename)) {
		trace1(TR_xdr_cryptkeyarg, 1);
		return (FALSE);
	}
	if (!xdr_des_block(xdrs, &objp->deskey)) {
		trace1(TR_xdr_cryptkeyarg, 1);
		return (FALSE);
	}
	trace1(TR_xdr_cryptkeyarg, 1);
	return (TRUE);
}

bool_t
xdr_cryptkeyarg2(xdrs, objp)
	XDR *xdrs;
	cryptkeyarg2 *objp;
{
	trace1(TR_xdr_cryptkeyarg2, 0);
	if (!xdr_netnamestr(xdrs, &objp->remotename)) {
		trace1(TR_xdr_cryptkeyarg2, 1);
		return (FALSE);
	}
	if (!xdr_netobj(xdrs, &objp->remotekey)) {
		trace1(TR_xdr_cryptkeyarg2, 1);
		return (FALSE);
	}
	if (!xdr_des_block(xdrs, &objp->deskey)) {
		trace1(TR_xdr_cryptkeyarg2, 1);
		return (FALSE);
	}
	trace1(TR_xdr_cryptkeyarg2, 1);
	return (TRUE);
}

bool_t
xdr_cryptkeyres(xdrs, objp)
	XDR *xdrs;
	cryptkeyres *objp;
{
	trace1(TR_xdr_cryptkeyres, 0);
	if (!xdr_keystatus(xdrs, &objp->status)) {
		trace1(TR_xdr_cryptkeyres, 1);
		return (FALSE);
	}
	switch (objp->status) {
	case KEY_SUCCESS:
		if (!xdr_des_block(xdrs, &objp->cryptkeyres_u.deskey)) {
			trace1(TR_xdr_cryptkeyres, 1);
			return (FALSE);
		}
		break;
	}
	trace1(TR_xdr_cryptkeyres, 1);
	return (TRUE);
}

bool_t
xdr_unixcred(xdrs, objp)
	XDR *xdrs;
	unixcred *objp;
{
	trace1(TR_xdr_unixcred, 0);
	if (!xdr_u_int(xdrs, (u_int *)&objp->uid)) {
		trace1(TR_xdr_unixcred, 1);
		return (FALSE);
	}
	if (!xdr_u_int(xdrs, (u_int *)&objp->gid)) {
		trace1(TR_xdr_unixcred, 1);
		return (FALSE);
	}
	if (!xdr_array(xdrs, (char **)&objp->gids.gids_val, (u_int *)&objp->gids.gids_len, MAXGIDS, sizeof(u_int), xdr_u_int)) {
		trace1(TR_xdr_unixcred, 1);
		return (FALSE);
	}
	trace1(TR_xdr_unixcred, 1);
	return (TRUE);
}

bool_t
xdr_getcredres(xdrs, objp)
	XDR *xdrs;
	getcredres *objp;
{
	trace1(TR_xdr_getcredres, 0);
	if (!xdr_keystatus(xdrs, &objp->status)) {
		trace1(TR_xdr_getcredres, 1);
		return (FALSE);
	}
	switch (objp->status) {
	case KEY_SUCCESS:
		if (!xdr_unixcred(xdrs, &objp->getcredres_u.cred)) {
			trace1(TR_xdr_getcredres, 1);
			return (FALSE);
		}
		break;
	}
	trace1(TR_xdr_getcredres, 1);
	return (TRUE);
}
